#include <grpcpp/grpcpp.h>
#include <grpcpp/health_check_service_interface.h>
#include <grpcpp/ext/proto_server_reflection_plugin.h>

#include "dr_dcmtk_idl.grpc.pb.h"

#include "service/pb_basic.h"
#include "service/pb_dcm.h"

void RunServer() {
  std::string server_address("0.0.0.0:6199");
  BasicServiceImpl basicService;
  DcmServiceImpl   dcmService;

  grpc::EnableDefaultHealthCheckService(true);
  grpc::reflection::InitProtoReflectionServerBuilderPlugin();
  ServerBuilder builder;
  builder.AddListeningPort(server_address, grpc::InsecureServerCredentials());
  builder.RegisterService(&basicService);
  builder.RegisterService(&dcmService);

  std::unique_ptr<Server> server(builder.BuildAndStart());
  std::cout << "Server listening on " << server_address << std::endl;

  server->Wait();
}

int main(int argc, char** argv) {
  RunServer();
  return 0;
}
